diff --git a/test/unit/commands/web/service_installer_test.rb b/test/unit/commands/web/service_installer_test.rb
new file mode 100644
index 000000000..f4a436285
--- /dev/null
+++ b/test/unit/commands/web/service_installer_test.rb
@@ -0,0 +1,142 @@
+require "test_helper"
+require "hive/commands/web/service_installer"
+
+class WebServiceInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_linux_writes_systemd_unit_with_run_foreground
+    with_tmp_dir do |dir|
+      commands = []
+      hive = File.join(dir, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0755, hive)
+
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux-gnu",
+        home: dir,
+        binary_path: hive,
+        systemctl_available: true,
+        runner: ->(argv) { commands << argv }
+      )
+
+      installer.install!(autostart: false)
+      unit = File.join(dir, ".config/systemd/user/hive-web.service")
+      assert File.exist?(unit)
+      body = File.read(unit)
+      assert_includes body, "ExecStart=#{hive} web run",
+                      "the web unit must run the foreground server so the service manager supervises it"
+      assert_includes body, "Environment=HIVE_BIN=#{hive}"
+      assert_includes body, "Environment=PATH="
+      assert_empty commands
+    end
+  end
+
+  def test_linux_autostart_invokes_enable_for_web_unit
+    with_tmp_dir do |dir|
+      commands = []
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: true,
+        runner: ->(argv) { commands << argv }
+      )
+
+      installer.install!(autostart: true)
+      assert_includes commands, %w[systemctl --user daemon-reload]
+      assert_includes commands, %w[systemctl --user enable --now hive-web]
+    end
+  end
+
+  def test_linux_without_systemd_writes_unit_and_reports_autostart_unavailable
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: false
+      )
+
+      result = installer.install!(autostart: true)
+      assert_equal :autostart_unavailable, result.kind
+      assert File.exist?(File.join(dir, ".config/systemd/user/hive-web.service"))
+      assert installer.messages.any? { |msg| msg.include?("autostart was not enabled") }
+    end
+  end
+
+  def test_macos_writes_plist_with_web_run
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "darwin23",
+        home: dir,
+        binary_path: "/opt/hive/bin/hive",
+        runner: ->(_argv) { true }
+      )
+
+      installer.install!(autostart: false)
+      plist = File.join(dir, "Library/LaunchAgents/local.hive-web.plist")
+      assert File.exist?(plist)
+      assert_includes File.read(plist), "<string>/opt/hive/bin/hive</string>"
+    end
+  end
+
+  def test_freebsd_returns_unsupported
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "freebsd14",
+        home: dir,
+        binary_path: "/tmp/hive"
+      )
+
+      result = installer.install!(autostart: true)
+      assert_equal :unsupported, result.kind
+      assert installer.messages.any? { |msg| msg.include?("web autostart not supported") }
+    end
+  end
+
+  def test_drifted_existing_unit_is_not_overwritten
+    with_tmp_dir do |dir|
+      unit = File.join(dir, ".config/systemd/user/hive-web.service")
+      FileUtils.mkdir_p(File.dirname(unit))
+      File.write(unit, "custom\n")
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: false
+      )
+
+      result = installer.install!(autostart: false)
+      assert_equal :drifted, result.kind
+      assert_equal "custom\n", File.read(unit)
+    end
+  end
+
+  def test_force_overwrites_drifted_unit_and_writes_backup
+    with_tmp_dir do |dir|
+      unit = File.join(dir, ".config/systemd/user/hive-web.service")
+      FileUtils.mkdir_p(File.dirname(unit))
+      File.write(unit, "previous-stale-content\n")
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: false
+      )
+
+      result = installer.install!(autostart: false, force: true)
+      assert_equal :upgraded, result.kind
+      backups = Dir["#{unit}.bak-*"]
+      assert_equal 1, backups.size
+      assert_equal "previous-stale-content\n", File.read(backups.first)
+      assert_includes File.read(unit), "ExecStart=/tmp/hive web run"
+    end
+  end
+
+  def test_launchd_label_and_platform
+    macos = Hive::Commands::Web::ServiceInstaller.new(host_os: "darwin23")
+    assert_equal "local.hive-web", macos.launchd_label
+    assert_equal "macos", macos.envelope_platform
+  end
+end
diff --git a/test/unit/commands/web/web_command_test.rb b/test/unit/commands/web/web_command_test.rb
new file mode 100644
index 000000000..5bf8a57a0
--- /dev/null
+++ b/test/unit/commands/web/web_command_test.rb
@@ -0,0 +1,231 @@
+require "test_helper"
+require "hive/commands/web"
+
+class WebCommandTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup
+    @home = Dir.mktmpdir("hive-webcmd")
+    @config = {
+      "registered_projects" => [],
+      "web" => {
+        "bind" => "127.0.0.1",
+        "port" => 4567,
+        "origin" => "http://127.0.0.1:4567",
+        "github" => { "owner" => nil, "client_id" => "test" },
+        "session_secret_file" => nil
+      }
+    }
+    File.write(File.join(@home, "config.yml"), @config.to_yaml)
+  end
+
+  def teardown
+    FileUtils.rm_rf(@home) if @home
+  end
+
+  def with_home
+    with_env("HIVE_HOME" => @home) do
+      yield
+    end
+  end
+
+  def test_unknown_subcommand_raises
+    with_home do
+      cmd = Hive::Commands::Web.new("bogus")
+      err = assert_raises(Hive::InvalidTaskPath) { cmd.call }
+      assert_includes err.message, "unknown subcommand"
+    end
+  end
+
+  def test_install_writes_unit_and_emits_json_envelope
+    with_home do
+      hive = File.join(@home, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0755, hive)
+
+      cmd = Hive::Commands::Web.new(
+        "install", json: true, home: @home, host_os: "linux",
+        systemctl_available: true, runner: ->(_argv) { true }
+      )
+      cmd.define_singleton_method(:current_binary_path) { hive }
+
+      out, _err = capture_io { cmd.call }
+      doc = JSON.parse(out)
+      assert_equal "hive-web-install", doc.fetch("schema")
+      assert_equal true, doc.fetch("ok")
+      assert_equal "written", doc.fetch("outcome")
+      assert_includes doc.fetch("target_path"), "hive-web.service"
+      assert_includes doc.fetch("target_path"), @home
+    end
+  end
+
+  def test_install_error_classes_carry_stable_exit_codes
+    assert_equal Hive::ExitCodes::SOFTWARE,
+                 Hive::Commands::Web::WebInstallFailed.new("x").exit_code
+    assert_equal Hive::ExitCodes::USAGE,
+                 Hive::Commands::Web::WebInstallDriftError.new("x").exit_code
+  end
+
+  def test_second_install_without_force_emits_drift_error_envelope
+    with_home do
+      hive = File.join(@home, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0755, hive)
+
+      # Pre-write a *different* unit to force drift. Commander path uses
+      # the injectable home so the unit lands under the sandbox. Pass
+      # systemctl_available to avoid the unknown-systemctl → unsupported
+      # outcome;
+      cmd = Hive::Commands::Web.new(
+        "install", json: true, home: @home, host_os: "linux", systemctl_available: false
+      )
+      cmd.define_singleton_method(:current_binary_path) { hive }
+      capture_io { cmd.call } # first install writes the unit
+
+      unit = File.join(@home, ".config/systemd/user/hive-web.service")
+      assert File.exist?(unit)
+      File.write(unit, "stale\n")
+
+      out, _err = capture_io do
+        assert_raises(Hive::Commands::Web::WebInstallDriftError) { cmd.call }
+      end
+      doc = JSON.parse(out)
+      assert_equal "hive-web-install", doc.fetch("schema")
+      assert_equal false, doc.fetch("ok")
+      assert_equal "drifted", doc.fetch("error_kind")
+      assert_equal 64, doc.fetch("exit_code")
+    end
+  end
+
+  def test_start_maps_to_systemctl_start
+    with_home do
+      commands = []
+      cmd = Hive::Commands::Web.new(
+        "start", home: @home, host_os: "linux",
+        runner: ->(argv) { commands << argv; true }
+      )
+      cmd.define_singleton_method(:current_binary_path) { "/tmp/hive" }
+      out, _err = capture_io { cmd.call }
+      assert_includes commands, %w[systemctl --user start hive-web]
+      assert_includes out, "start requested"
+    end
+  end
+
+  def test_stop_maps_to_systemctl_stop
+    with_home do
+      commands = []
+      cmd = Hive::Commands::Web.new(
+        "stop", home: @home, host_os: "linux",
+        runner: ->(argv) { commands << argv; true }
+      )
+      capture_io { cmd.call }
+      assert_includes commands, %w[systemctl --user stop hive-web]
+    end
+  end
+
+  def test_start_json_emits_hive_web_start_envelope
+    with_home do
+      cmd = Hive::Commands::Web.new(
+        "start", json: true, home: @home, host_os: "linux",
+        runner: ->(_argv) { true }
+      )
+      out, _err = capture_io { cmd.call }
+      doc = JSON.parse(out)
+      assert_equal "hive-web-start", doc.fetch("schema")
+      assert_equal true, doc.fetch("ok")
+      assert_includes doc.fetch("unit_path"), "hive-web.service"
+    end
+  end
+
+  def test_stop_json_emits_hive_web_stop_envelope
+    with_home do
+      cmd = Hive::Commands::Web.new(
+        "stop", json: true, home: @home, host_os: "linux",
+        runner: ->(_argv) { true }
+      )
+      out, _err = capture_io { cmd.call }
+      doc = JSON.parse(out)
+      assert_equal "hive-web-stop", doc.fetch("schema")
+      assert_equal true, doc.fetch("ok")
+      assert_includes doc.fetch("unit_path"), "hive-web.service"
+    end
+  end
+
+  def test_status_maps_to_systemctl_is_active
+    with_home do
+      commands = []
+      cmd = Hive::Commands::Web.new(
+        "status", home: @home, host_os: "linux",
+        runner: ->(argv) { commands << argv; false }
+      )
+      out, _err = capture_io do
+        assert_raises(Hive::Error) { cmd.call }
+      end
+      assert_includes commands, %w[systemctl --user is-active hive-web]
+      assert_includes out, "running: no"
+    end
+  end
+
+  def test_status_json_envelope
+    with_home do
+      cmd = Hive::Commands::Web.new(
+        "status", json: true, home: @home, host_os: "linux",
+        runner: ->(_argv) { false }
+      )
+      out, _err = capture_io { cmd.call }
+      doc = JSON.parse(out)
+      assert_equal "hive-web-status", doc.fetch("schema")
+      assert_equal false, doc.fetch("running")
+      assert_equal Hive::VERSION, doc.fetch("current_version")
+    end
+  end
+
+  def test_refused_bind_loopback_never_refused
+    with_home do
+      cmd = Hive::Commands::Web.new("run")
+      refute cmd.send(:refused_bind?, bind: "127.0.0.1")
+      refute cmd.send(:refused_bind?, bind: "::1")
+      refute cmd.send(:refused_bind?, bind: "localhost")
+    end
+  end
+
+  def test_refused_bind_non_loopback_without_owner_refused
+    with_home do
+      cmd = Hive::Commands::Web.new("run")
+      assert cmd.send(:refused_bind?, bind: "0.0.0.0"),
+             "non-loopback bind with no owner and no --allow-non-loopback must be refused (fail-closed)"
+    end
+  end
+
+  def test_refused_bind_allowed_with_flag
+    with_home do
+      cmd = Hive::Commands::Web.new("run", allow_non_loopback: true)
+      refute cmd.send(:refused_bind?, bind: "0.0.0.0"),
+             "--allow-non-loopback must permit a non-loopback bind"
+    end
+  end
+
+  def test_refused_bind_with_owner_allows_non_loopback
+    with_home do
+      @config["web"]["github"]["owner"] = "someone"
+      File.write(File.join(@home, "config.yml"), @config.to_yaml)
+      cmd = Hive::Commands::Web.new("run")
+      refute cmd.send(:refused_bind?, bind: "0.0.0.0"),
+             "a non-loopback bind with web.github.owner set is authorized (owner gate present)"
+    end
+  end
+
+  def test_refused_bind_reflects_owner_change
+    with_home do
+      cmd = Hive::Commands::Web.new("run")
+      assert cmd.send(:refused_bind?, bind: "127.0.0.2"),
+             "non-loopback with no owner must be refused"
+      @config["web"]["github"]["owner"] = "someone"
+      File.write(File.join(@home, "config.yml"), @config.to_yaml)
+      cmd2 = Hive::Commands::Web.new("run")
+      refute cmd2.send(:refused_bind?, bind: "127.0.0.2")
+    end
+  end
+end
diff --git a/test/unit/exit_codes_test.rb b/test/unit/exit_codes_test.rb
index af2c6f8fa..52a80aabb 100644
--- a/test/unit/exit_codes_test.rb
+++ b/test/unit/exit_codes_test.rb
@@ -11,6 +11,7 @@ class ExitCodesTest < Minitest::Test
     assert_equal 3,  Hive::ExitCodes::TASK_IN_ERROR
     assert_equal 4,  Hive::ExitCodes::WRONG_STAGE
     assert_equal 64, Hive::ExitCodes::USAGE
+    assert_equal 65, Hive::ExitCodes::FIX_REQUIRED
     assert_equal 70, Hive::ExitCodes::SOFTWARE
     assert_equal 75, Hive::ExitCodes::TEMPFAIL
     assert_equal 78, Hive::ExitCodes::CONFIG
diff --git a/test/unit/schema_files_test.rb b/test/unit/schema_files_test.rb
index 2d10237de..0d4e722a2 100644
--- a/test/unit/schema_files_test.rb
+++ b/test/unit/schema_files_test.rb
@@ -1476,6 +1476,7 @@ class SchemaFilesTest < Minitest::Test
     producer_required = %w[
       schema schema_version ok running pid uptime_sec pid_file log_file
       service_installed service_enabled unit_path current_version update_nudge
+      daemon_binary daemon_version drift_status drifted
     ].sort
     assert_equal producer_required, schema_required,
                  "schema/producer required-key drift in hive-daemon-status.v1.json"
diff --git a/test/unit/web/auth_policy_test.rb b/test/unit/web/auth_policy_test.rb
new file mode 100644
index 000000000..c814ae870
--- /dev/null
+++ b/test/unit/web/auth_policy_test.rb
@@ -0,0 +1,33 @@
+require "test_helper"
+require "hive/web/auth_policy"
+
+class AuthPolicyTest < Minitest::Test
+  UNOWNED = { "github" => { "owner" => nil } }.freeze
+  OWNED = { "github" => { "owner" => "someone" } }.freeze
+
+  def test_loopback_binds
+    %w[127.0.0.1 ::1 localhost].each do |b|
+      assert Hive::Web::AuthPolicy.loopback_bind?(b), "#{b} must be loopback"
+    end
+    refute Hive::Web::AuthPolicy.loopback_bind?("0.0.0.0")
+    refute Hive::Web::AuthPolicy.loopback_bind?("192.168.1.5")
+  end
+
+  def test_single_user_local_only_when_loopback_and_unowned
+    assert Hive::Web::AuthPolicy.single_user_local?(bind: "127.0.0.1", config: UNOWNED)
+    refute Hive::Web::AuthPolicy.single_user_local?(bind: "0.0.0.0", config: UNOWNED),
+           "a non-loopback bind is never single-user-local"
+    refute Hive::Web::AuthPolicy.single_user_local?(bind: "127.0.0.1", config: OWNED),
+           "an owner-claimed box keeps the owner gate even on loopback"
+  end
+
+  def test_allows_unauthenticated_loopback_request_when_unowned
+    assert Hive::Web::AuthPolicy.allows_unauthenticated?(host: "127.0.0.1", config: UNOWNED)
+    assert Hive::Web::AuthPolicy.allows_unauthenticated?(host: "::1", config: UNOWNED)
+    assert Hive::Web::AuthPolicy.allows_unauthenticated?(host: "localhost", config: UNOWNED)
+    refute Hive::Web::AuthPolicy.allows_unauthenticated?(host: "10.0.0.8", config: UNOWNED),
+           "a non-loopback request must never bypass the owner gate"
+    refute Hive::Web::AuthPolicy.allows_unauthenticated?(host: "127.0.0.1", config: OWNED),
+           "an owner-claimed box must not bypass the gate even on loopback"
+  end
+end
diff --git a/test/unit/web/web_command_test.rb b/test/unit/web/web_command_test.rb
index 11de4ab06..368161332 100644
--- a/test/unit/web/web_command_test.rb
+++ b/test/unit/web/web_command_test.rb
@@ -34,18 +34,36 @@ class WebCommandTest < Minitest::Test
     end
   end
 
-  def test_public_bind_without_https_origin_warns
+  # U4 fail-closed bind semantics (replaces the old loud-but-warns-only
+  # `warn_on_public_bind`): loopback always allowed; a non-loopback bind
+  # without web.github.owner and without --allow-non-loopback is REFUSED.
+  def test_refused_bind_is_fail_closed
     with_tmp_global_config do
       command = Hive::Commands::Web.new
-      _out, err = capture_io do
-        command.send(:warn_on_public_bind, "0.0.0.0", { "origin" => "http://example.test" })
-      end
-      assert_match(/WARNING binding 0.0.0.0/, err, "plain-http public bind must warn about Host validation")
+      refute command.send(:refused_bind?, bind: "127.0.0.1"),
+             "loopback bind must never be refused (single-user local mode)"
+      refute command.send(:refused_bind?, bind: "::1")
+      assert command.send(:refused_bind?, bind: "0.0.0.0"),
+             "a non-loopback bind with no owner and no --allow-non-loopback must be refused (fail-closed)"
+    end
+  end
 
-      _out, err = capture_io do
-        command.send(:warn_on_public_bind, "0.0.0.0", { "origin" => "https://example.test" })
+  def test_refused_bind_allowed_with_flag_or_owner
+    with_tmp_global_config do
+      flagged = Hive::Commands::Web.new(allow_non_loopback: true)
+      refute flagged.send(:refused_bind?, bind: "0.0.0.0"),
+             "--allow-non-loopback must permit a non-loopback bind"
+
+      # With web.github.owner set, the owner gate authorizes non-loopback.
+      with_tmp_dir do |dir|
+        File.write(File.join(dir, "config.yml"),
+                   { "web" => { "github" => { "owner" => "someone" } } }.to_yaml)
+        with_env("HIVE_HOME" => dir) do
+          owned = Hive::Commands::Web.new
+          refute owned.send(:refused_bind?, bind: "0.0.0.0"),
+                 "a non-loopback bind with web.github.owner set is authorized"
+        end
       end
-      assert_empty err, "an https origin implies a fronting proxy — no warning"
     end
   end
   # Drive the full "app found" path with a stub Rails app: db:prepare
diff --git a/web/app/controllers/application_controller.rb b/web/app/controllers/application_controller.rb
index 2a1e5e28f..fe397d2f1 100644
--- a/web/app/controllers/application_controller.rb
+++ b/web/app/controllers/application_controller.rb
@@ -11,7 +11,7 @@ class ApplicationController < ActionController::Base
 
   before_action :require_login
 
-  helper_method :current_login
+  helper_method :current_login, :local_single_user_allow?
 
   # Hive's typed errors are operator-readable by design ("task not in stage",
   # "invalid clone URL"). Render them on an error page instead of a blank
@@ -49,7 +49,26 @@ class ApplicationController < ActionController::Base
     session[:github_login]
   end
 
+  # Local single-user mode (U4): a loopback request against a box with no
+  # claimed owner bypasses the GitHub owner gate entirely. Shares the
+  # loopback predicate with the CLI's fail-closed bind check (Web::AuthPolicy)
+  # so the CLI can never green-light a bind the app will 403, and the app
+  # never silently allows a non-loopback request. An owner-claimed box (or a
+  # non-loopback request) keeps the gate.
+  #
+  # Loopback-ness is derived from `request.remote_ip` (the trusted client
+  # address) NOT `request.host` — the Host header is attacker-controlled, so
+  # a request spoofing `Host: 127.0.0.1` against a non-loopback bind could
+  # otherwise skip the owner gate entirely (Risk-2 fail-closed break).
+  def local_single_user_allow?
+    Hive::Web::AuthPolicy.allows_unauthenticated?(
+      host: request.remote_ip,
+      config: Hive::Config.load_global_web
+    )
+  end
+
   def require_login
+    return if local_single_user_allow?
     return redirect_to login_path unless current_login
 
     # Sessions must track the CURRENT owner, not the owner at sign-in time:
diff --git a/web/app/controllers/daemon_controller.rb b/web/app/controllers/daemon_controller.rb
new file mode 100644
index 000000000..2903f8f9d
--- /dev/null
+++ b/web/app/controllers/daemon_controller.rb
@@ -0,0 +1,55 @@
+require "hive/invoked_binary"
+require "hive/pid_file"
+
+# U5: daemon repair/restart surfaced in the web UI. Only the loopback
+# single-user case (a loopback request against a box with no claimed
+# owner) may trigger this — the shared Web::AuthPolicy guard is the same
+# one the CLI and require_login use, so a non-loopback or owner-claimed
+# request is always refused even if the route is hit directly.
+class DaemonController < ApplicationController
+  # Reads the daemon's pidfile the same way `hive daemon status` does —
+  # stale files and reused PIDs don't count as alive (mirrors the
+  # HealthController::DaemonProbe so liveness is consistent everywhere).
+  class DaemonProbe
+    include Hive::PidFile
+
+    def pid_file
+      File.join(Hive::Paths.state_home, ".daemon.pid")
+    end
+  end
+
+  # Repair/restart the daemon when binary/version drift is detected by the
+  # health probe. Delegates to the explicit `hive daemon repair` path (the
+  # same one `hive setup` uses) — drift is never auto-fixed elsewhere. The
+  # subprocess runs the SAME binary the CLI resolves rather than a bare
+  # `hive` from the web process's PATH, which could be a different/stale
+  # binary (the exact drift this endpoint exists to repair).
+  def restart
+    unless local_single_user_allow?
+      return render json: { ok: false, error: "not allowed" }, status: :forbidden
+    end
+    return render json: { ok: false, error: "daemon not running" }, status: :conflict unless daemon_running?
+
+    binary = Hive::InvokedBinary.path || ENV["HIVE_BIN"]
+    unless binary
+      return render json: { ok: false, error: "cannot resolve hive binary" }, status: :internal_server_error
+    end
+
+    # `hive daemon repair` on Linux runs `systemctl --user restart
+    # hive-daemon`, which can block up to TimeoutStopSec (900s) while
+    # in-flight children drain. Never block a web worker (and its
+    # thread-pool slot) on that — spawn the repair detached and report
+    # acceptance immediately; the status grid re-checks drift on its next
+    # refresh.
+    pid = Process.spawn(binary, "daemon", "repair",
+                        out: File::NULL, err: File::NULL, pgroup: true)
+    Process.detach(pid)
+    render json: { ok: true, started: true, repaired: false }
+  end
+
+  private
+
+  def daemon_running?
+    DaemonProbe.new.read_live_pid
+  end
+end
diff --git a/web/app/controllers/health_controller.rb b/web/app/controllers/health_controller.rb
index cda67e408..fe93b442e 100644
--- a/web/app/controllers/health_controller.rb
+++ b/web/app/controllers/health_controller.rb
@@ -1,4 +1,5 @@
 require "hive/pid_file"
+require "hive/daemon/drift"
 
 class HealthController < ApplicationController
   skip_before_action :require_login
@@ -23,7 +24,24 @@ class HealthController < ApplicationController
 
     daemon_pid = DaemonProbe.new.read_live_pid
     if daemon_pid
-      render json: { ok: true, daemon: { running: true, pid: daemon_pid } }
+      # U5: surface the RUNNING daemon's binary/version consistency with the
+      # CLI (drift) so the web status grid can offer a repair/restart. Drift
+      # is reported, never silently auto-fixed here.
+      drift =
+        begin
+          Hive::Daemon::Drift.new(pid: daemon_pid).resolve
+        rescue StandardError
+          { "status" => "unverified", "drifted" => nil }
+        end
+      render json: {
+        ok: true,
+        daemon: {
+          running: true, pid: daemon_pid,
+          binary: drift["binary"], version: drift["version"],
+          current_version: Hive::VERSION,
+          drift_status: drift["status"], drifted: drift["drifted"]
+        }
+      }
     else
       render json: { ok: false, daemon: { running: false } }, status: :service_unavailable
     end
diff --git a/web/app/controllers/status_controller.rb b/web/app/controllers/status_controller.rb
index c44440a83..42b59f020 100644
--- a/web/app/controllers/status_controller.rb
+++ b/web/app/controllers/status_controller.rb
@@ -1,6 +1,37 @@
+require "hive/pid_file"
+require "hive/daemon/drift"
+
 class StatusController < ApplicationController
   def index
     @payload = StatusBroadcaster.snapshot
     @projects = @payload.fetch("projects", [])
+    @daemon = daemon_status
+  end
+
+  private
+
+  # U5: surface daemon health/repair in the status grid. Resolves the live
+  # daemon's binary/version consistency with the CLI (drift) using the same
+  # pidfile liveness rules as `/health?deep=1`. Never raises out of the grid
+  # render — a failed probe degrades to `running: false` so one bad daemon
+  # read can't blank the whole dashboard.
+  def daemon_status
+    daemon_pid = HealthController::DaemonProbe.new.read_live_pid
+    return { running: false } unless daemon_pid
+
+    drift =
+      begin
+        Hive::Daemon::Drift.new(pid: daemon_pid).resolve
+      rescue StandardError
+        { "status" => "unverified", "drifted" => nil }
+      end
+    {
+      running: true,
+      pid: daemon_pid,
+      drift_status: drift["status"],
+      drifted: drift["drifted"]
+    }
+  rescue StandardError
+    { running: false }
   end
 end
diff --git a/web/app/views/status/index.html.erb b/web/app/views/status/index.html.erb
index 25bcdf793..c2ab1b192 100644
--- a/web/app/views/status/index.html.erb
+++ b/web/app/views/status/index.html.erb
@@ -26,6 +26,26 @@
   </aside>
   <div class="status-main">
 
+<%# U5: daemon health/repair surfaced in the status grid. A down or drifted
+    daemon is a box-level condition, not a per-project one, so it sits above
+    the project grid. Repair delegates to the same `hive daemon repair` path
+    the CLI uses; the button only renders when drift was actually detected AND
+    the request is in single-user local mode (the same gate the controller
+    enforces — an owner-claimed box would otherwise show a button the
+    endpoint then 403s). %>
+<% if @daemon && @daemon[:running] && @daemon[:drifted] && local_single_user_allow? %>
+  <div class="daemon-status daemon-status-drifted">
+    <span>Daemon is running a different binary/version than the CLI.</span>
+    <%= button_to "Repair daemon", daemon_restart_path, method: :post,
+          class: "btn btn-danger btn-sm", form_class: "inline-form",
+          data: { turbo_confirm: "Rewrite the daemon unit to the CLI's binary and restart it?" } %>
+  </div>
+<% elsif @daemon && !@daemon[:running] %>
+  <div class="daemon-status daemon-status-down">
+    <span>Daemon is not running — new tasks will not be picked up automatically.</span>
+  </div>
+<% end %>
+
 <%# data-turbo-permanent: a morph must never touch the composer — it holds
     typed-but-unsent idea text and staged image attachments (Stimulus state
     the server can't re-render). %>
diff --git a/web/config/initializers/hive.rb b/web/config/initializers/hive.rb
index f2792b55a..881e907a0 100644
--- a/web/config/initializers/hive.rb
+++ b/web/config/initializers/hive.rb
@@ -3,6 +3,7 @@
 require "hive"
 require "hive/media_manifest"
 require "hive/web/github_auth"
+require "hive/web/auth_policy"
 require "hive/web/status_feed"
 require "hive/web/dispatcher"
 require "hive/web/agents_auth"
diff --git a/web/config/routes.rb b/web/config/routes.rb
index 659576df3..21f1164a2 100644
--- a/web/config/routes.rb
+++ b/web/config/routes.rb
@@ -3,6 +3,10 @@ Rails.application.routes.draw do
   get "health" => "health#show"
   get "up" => "rails/health#show", as: :rails_health_check
 
+  # U5: daemon repair/restart surfaced in the web UI — loopback single-user
+  # only (the controller refuses otherwise).
+  post "daemon/restart" => "daemon#restart", as: :daemon_restart
+
   # GitHub device-flow sign-in (RFC 8628). Start is a POST (it creates a
   # GitHub device code); the wait page polls the grant.
   # Development/test only: the auth seam Capybara logs in through (and dev
